 ; Copyright 2000 EMT Software, Inc.
 ;
(defun C:CHGPTS (/ #BLK #DEL #PTS #SCL #PLYR #ELS #LYR #CNT #NUM #SSET
                   #CLYR #ECHO #OLDERR cad_error@)

  (defun cad_error@  (%A)

    (setq *error* #OLDERR)
    (setvar "cmdecho" #ECHO)
    (setvar "clayer"  #CLYR)

    (cond
      ((= %A "Function cancelled") nil)
      (T (princ (strcat "\nerror: " %A ":\n"))))
    (princ))

  (setq #OLDERR *error*)
  (setq #ECHO (getvar "cmdecho"))
  (setq #CLYR (getvar "clayer"))

  (setq *error* cad_error@)
  (setvar "cmdecho" 0)

  (initget "Select Layer All")
  (setq #PTS (getkword "\nSelect points by [Select/Layer/All] <Select>: "))
  (if (not #PTS) (setq #PTS "Select"))

  (initget "Yes No")
  (setq #DEL (getkword "\nReplace points in the drawing [Yes/No] <No>: "))
  (if (not #DEL) (setq #DEL "No"))
  (if (= #DEL "Yes")
    (setq #BLK (getstring "\nEnter block name to replace points: "))
    (setq #BLK (getstring "\nEnter block name to insert on points: ")))

  (setq #SCL (getreal "\nEnter scale factor: <1.0>"))
  (if (not #SCL) (setq #SCL 1.0))

  (if (/= #BLK "")
    (cond
      ((= #PTS "Select")
       (setq #SSET (ssget (list (cons 0 "POINT")))
             #CNT  0)
       (if (not #SSET)
         (setq #NUM 0)
         (setq #NUM (sslength #SSET)))
       (while (/= #CNT #NUM)
         (setq #ELS (entget (ssname #SSET #CNT))
               #LYR (cdr (assoc 8 #ELS)))
;         (if #LYR
;           (setvar "clayer" #LYR)
;           (setvar "clayer" #CLYR))
         (command "_.insert" #BLK (cdr (assoc 10 #ELS)) #SCL "" "")
         (if (and (= #DEL "Yes") (= (cdr (assoc 0 #ELS)) "POINT"))
           (entdel (cdr (assoc -1 #ELS))))
         (setq #CNT (1+ #CNT))))
      ((= #PTS "Layer")
       (setq #PLYR (getstring "\nSelect points on what layer: <current>"))
       (if (= #PLYR "")
         (setq #PLYR (getvar "clayer")))
       (setq #SSET (ssget "X" (list (cons 0 "POINT")(cons 8 #PLYR)))
             #CNT  0)
       (if (not #SSET)
         (setq #NUM 0)
         (setq #NUM (sslength #SSET)))
       (while (/= #CNT #NUM)
         (setq #ELS (entget (ssname #SSET #CNT))
               #LYR (cdr (assoc 8 #ELS)))
;         (if #LYR
;           (setvar "clayer" #LYR)
;           (setvar "clayer" #CLYR))
         (command "_.insert" #BLK (cdr (assoc 10 #ELS)) #SCL "" "")
         (if (and (= #DEL "Yes") (= (cdr (assoc 0 #ELS)) "POINT"))
           (entdel (cdr (assoc -1 #ELS))))
         (setq #CNT (1+ #CNT))))
      ((= #PTS "All")
       (setq #SSET (ssget "X" (list (cons 0 "POINT")))
             #CNT  0)
       (if (not #SSET)
         (setq #NUM 0)
         (setq #NUM (sslength #SSET)))
       (while (/= #CNT #NUM)
         (setq #ELS (entget (ssname #SSET #CNT))
               #LYR (cdr (assoc 8 #ELS)))
;         (if #LYR
;           (setvar "clayer" #LYR)
;           (setvar "clayer" #CLYR))
         (command "_.insert" #BLK (cdr (assoc 10 #ELS)) #SCL "" "")
         (if (and (= #DEL "Yes") (= (cdr (assoc 0 #ELS)) "POINT"))
           (entdel (cdr (assoc -1 #ELS))))
         (setq #CNT (1+ #CNT))))))

  (setq *error* #OLDERR)
  (setvar "cmdecho" #ECHO)
  (setvar "clayer"  #CLYR)

  (princ))


;;; Uncomment for the language needed.
;(princ "\n\nCHGPTS͂ĊJn")  ; For Japanese.
(princ "\n\nType CHGPTS to start.") ; For English.

(princ)
